Codeforces:F - Elongated Matrix

题目链接:http://codeforces.com/contest/1102/problem/F


F - Elongated Matrix

time limit per test 4 seconds
memory limit per test 256 megabytes

Porblem Description

You are given a matrix a, consisting of n rows and m columns. Each cell contains an integer in it.

You can change the order of rows arbitrarily (including leaving the initial order), but you can’t change the order of cells in a row. After you pick some order of rows, you traverse the whole matrix the following way: firstly visit all cells of the first column from the top row to the bottom one, then the same for the second column and so on. During the traversal you write down the sequence of the numbers on the cells in the same order you visited them. Let that sequence be s1,s2,…,snm.

The traversal is k-acceptable if for all i (1≤i≤nm−1) |si−si+1|≥k.

Find the maximum integer k such that there exists some order of rows of matrix a that it produces a k-acceptable traversal.

Input

The first line contains two integers n and m (1≤n≤16, 1≤m≤10^4, 2≤nm) — the number of rows and the number of columns, respectively.

Each of the next n lines contains m integers (1≤ai,j≤10^9) — the description of the matrix.

Output

Print a single integer k— the maximum number such that there exists some order of rows of matrix a that it produces an k-acceptable traversal.

Examples

Input
4 2
9 9
10 8
5 3
4 3

Output
5

Input
2 4
1 2 3 4
10 3 7 3

Output
0

Input
6 1
3
6
2
5
1
4

Output
3

Note

In the first example you can rearrange rows as following to get the 5-acceptable traversal:
5 3
10 8
4 3
9 9

Then the sequence s will be [5,10,4,9,3,8,3,9]. Each pair of neighbouring elements have at least k=5 difference between them.

In the second example the maximum k=0, any order is 0-acceptable.

In the third example the given order is already 3-acceptable, you can leave it as it is.



解题心得:
  • 队友告诉我这是一个旅行商问题,但是我并不会,所以看了看了大佬怎么写的,然后自己写了一遍。
  • 首先看n和m的范围,n是16这就很明显的一个状压的标志了。整体思路就是状压+记忆化,因为复杂度的原因需要预处理每两行之间对应差的最小值。然后枚举第i行后面需要移动的所有状态。用dp[i][j]表示第i行j状态(如果j二进制状态位置为k的地方是0代表第k行需要移动到i行后面),然后递归到需要移动的第k行。



#include 
using namespace std;
const int maxn = 20;
const int maxm = 1e4+100;

int num[maxn][maxm], va[maxn][maxm], va2[maxn][maxm], dp[maxn][(1<<17)];
int n, m;

void init() {
    scanf("%d%d",&n, &m);
    for(int i=0;i<n;i++) {
        for (int j = 0; j < m; j++) {
            scanf("%d", &num[i][j]);
        }
    }

    for(int i=0;i<n;i++) {
        for(int j=0;j<n;j++) {
            va[i][j] = va2[i][j] = INT_MAX;
            for(int k=0;k<m;k++){
                va[i][j] = min(va[i][j], abs(num[i][k] - num[j][k]));
                if(k != 0)
                    va2[i][j] = min(va2[i][j], abs(num[i][k] - num[j][k-1]));//拼接成一个数组之后,拼接中间产生的差值
            }
        }
    }
}

int row;

int dfs(int pre, int state) {
    if(state == ((1<<n)-1)) return va2[row][pre];//无法再交换行的未知
    if(dp[pre][state] != -1) return dp[pre][state];//这个状态曾经被查找过

    dp[pre][state] = 0;
    for(int i=0;i<n;i++) {
        if(state & (1<<i))continue;
        dp[pre][state] = max(dp[pre][state], min(dfs(i, (state|(1<<i))), va[pre][i]));//递归
    }

    return dp[pre][state];
}

int main() {
    //freopen("1.in", "r", stdin);
    init();
    int ans = 0;
    for(row=0; row<n; row++) {
        memset(dp, -1, sizeof(dp));
        ans = max(ans, dfs(row, (1<<row)));//后面可以交换的所有状态
    }
    printf("%d", ans);
    return 0;
}

你可能感兴趣的:(动态规划-记忆化搜索,动态规划-状压dp,动态规划-旅行商问题)